'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ScrollBar = require('../common/ScrollBar');

var _ScrollBar2 = _interopRequireDefault(_ScrollBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * ScrollerBase
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 提供在移动端支持滚动的容器,支持手势惯性和弹性,利用CSS3实现.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 支持IOS和Android
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by TonyJiang on 16/5/7.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


//贝塞尔曲线
var cubic = {

    //超出边界减速
    quadratic: 'cubic-bezier(0.25, 0.46, 0.45, 0.94)',

    //回弹曲线
    outCirc: 'cubic-bezier(0.075, 0.82, 0.165, 1)',

    //惯性曲线
    outCubic: 'cubic-bezier(0.165, 0.84, 0.44, 1)',

    //常规曲线
    circular: 'cubic-bezier(0.1, 0.57, 0.1, 1)'
};

var ScrollerBase = function (_React$Component) {
    _inherits(ScrollerBase, _React$Component);

    function ScrollerBase(props, context) {
        _classCallCheck(this, ScrollerBase);

        var _this = _possibleConstructorReturn(this, (ScrollerBase.__proto__ || Object.getPrototypeOf(ScrollerBase)).call(this, props, context));

        _this._state = {
            reachTop: false,
            reachBottom: false,
            deltaY: 0,
            startDeltaY: 0,

            lastScrollHeight: 0,
            lastClientHeight: 0

        };
        _this._checkTimer = 0;
        _this._method = {
            updateScrollBar: function updateScrollBar() {
                if (!_this._hasScrollBar) {
                    return;
                }
                var _this$refs$domNode = _this.refs.domNode,
                    scrollTop = _this$refs$domNode.scrollTop,
                    offsetHeight = _this$refs$domNode.offsetHeight,
                    scrollHeight = _this$refs$domNode.scrollHeight;
                var scrollBar = _this.refs.scrollBar;


                scrollBar.show();
                scrollBar.scrollTo({ deltaY: scrollTop, contentHeight: scrollHeight, clientHeight: offsetHeight });

                if (!_this._state.touching) {
                    clearTimeout(_this._hideScrollbarUI);
                    _this._hideScrollbarUI = setTimeout(function () {
                        scrollBar.hide();
                    }, 500);
                }
            },

            startCheckContentHeightUpdated: function startCheckContentHeightUpdated() {
                _this._checkTimer = setInterval(function () {
                    _this._method.checkContentHeightUpdated();
                }, 16.7);
            },

            stopCheckContentHeightUpdated: function stopCheckContentHeightUpdated() {
                clearInterval(_this._checkTimer);
            },

            //检测内容高度是否发生变化, 然后重新判断reach
            checkContentHeightUpdated: function checkContentHeightUpdated() {
                var _this$_state = _this._state,
                    lastScrollHeight = _this$_state.lastScrollHeight,
                    lastClientHeight = _this$_state.lastClientHeight;
                var _this$refs$domNode2 = _this.refs.domNode,
                    scrollHeight = _this$refs$domNode2.scrollHeight,
                    clientHeight = _this$refs$domNode2.clientHeight;

                //如果视窗大小和内容高度没有发生变化, 直接返回

                if (scrollHeight == lastScrollHeight && clientHeight == lastClientHeight) {
                    return;
                }

                _this._eventHandler.scroll(true);

                _this._state.lastScrollHeight = scrollHeight;
                _this._state.lastClientHeight = clientHeight;
            }

        };
        _this._eventHandler = {
            touchStart: function touchStart(e) {
                _this._state.touching = true;
                if (_this._hasScrollBar) {
                    _this.refs.scrollBar.show();
                }
            },

            touchEnd: function touchEnd() {
                _this._state.touching = false;
                if (_this._hasScrollBar) {
                    _this.refs.scrollBar.hide();
                }
            },

            scroll: function scroll() {
                var isCheck = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
                var _this$refs$domNode3 = _this.refs.domNode,
                    scrollTop = _this$refs$domNode3.scrollTop,
                    offsetHeight = _this$refs$domNode3.offsetHeight,
                    scrollHeight = _this$refs$domNode3.scrollHeight;

                //更新scrollbar位置

                _this._method.updateScrollBar();

                var topLine = scrollTop;
                var bottomLine = scrollTop + offsetHeight;

                //检测是否需要派发 onReachTop 事件
                //本来应该是==0 但是由于ios有弹性,持续上拉会变成负数,所以兼容ios
                if (topLine <= 0) {
                    if (!_this._state.reachTop) {
                        _this._state.reachTop = true;
                        _this._eventHandler.reachTop();
                    }
                } else {
                    if (_this._state.reachTop) {
                        _this._state.reachTop = false;
                        _this._eventHandler.leaveTop();
                    }
                }

                //检测是否需要派发 onReachBottom 事件
                //本来应该是==scrollHeight 但是由于ios有弹性,持续下拉会持续增加,所以兼容ios
                //scrollHeight - 2 是因为在浏览器中, rem转px时, 会有小数问题, 所以导致scrollHeight比scrollTop+contentHeight大1~2, 设置2保险;
                if (bottomLine >= scrollHeight - 2) {

                    if (!_this._state.reachBottom) {
                        _this._state.reachBottom = true;
                        _this._eventHandler.reachBottom();
                    }
                } else {

                    if (_this._state.reachBottom) {
                        _this._state.reachBottom = false;
                        _this._eventHandler.leaveBottom();
                    }
                }

                //派发 onScroll 事件
                if (!isCheck) {
                    _this.props.onScroll({
                        scrollTop: scrollTop, offsetHeight: offsetHeight, scrollHeight: scrollHeight
                    });
                }
            },

            reachTop: function reachTop() {
                _this.props.onReachTop();
            },

            leaveTop: function leaveTop() {
                _this.props.onLeaveTop();
            },

            reachBottom: function reachBottom() {
                _this.props.onReachBottom();
            },

            leaveBottom: function leaveBottom() {
                _this.props.onLeaveBottom();
            }
        };
        return _this;
    }

    _createClass(ScrollerBase, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._randomClassName = 'scroller_' + new Date().getTime();
            this._hasScrollBar = mutants.env.os != mutants.env.constant.os.ios;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            //渲染完毕后,处理一次当前scroll的状态, setTimeout保证不会因为父类没有完成DidMount
            setTimeout(function () {
                _this2._eventHandler.scroll();
            }, 1);

            this._method.startCheckContentHeightUpdated();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._method.stopCheckContentHeightUpdated();
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var _refs$domNode = this.refs.domNode,
                scrollTop = _refs$domNode.scrollTop,
                offsetHeight = _refs$domNode.offsetHeight,
                scrollHeight = _refs$domNode.scrollHeight;


            if (this._state.reachTop && scrollTop != 0) {
                this._state.reachTop = false;
                this._eventHandler.leaveTop();
            } else if (!this._state.reachTop && scrollTop == 0) {
                this._state.reachTop = true;
                this._eventHandler.reachTop();
            }

            if (this._state.reachBottom && scrollTop + offsetHeight < scrollHeight) {
                this._state.reachBottom = false;
                this._eventHandler.leaveBottom();
            } else if (!this._state.reachBottom && scrollTop + offsetHeight == scrollHeight) {
                this._state.reachBottom = true;
                this._eventHandler.reachBottom();
            }

            if (this._hasScrollBar) {
                this._method.updateScrollBar();
            }

            //派发 onScroll 事件
            this.props.onScroll({
                scrollTop: scrollTop, offsetHeight: offsetHeight, scrollHeight: scrollHeight
            });
        }
    }, {
        key: 'scrollTo',
        value: function scrollTo(deltaY) {
            var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

            this.refs.domNode.scrollTop = deltaY;
        }
    }, {
        key: '_getStyles',
        value: function _getStyles() {

            var styles = {
                height: '100%',
                width: '100%'
            };

            var touchOverrideStyles = {
                WebkitOverflowScrolling: 'touch',
                overflowY: 'scroll'
            };

            if (mutants.env.os != mutants.env.constant.os.ios) {
                touchOverrideStyles.WebkitScrollbar = '';
            }

            return Object.assign(styles, this.props.style, touchOverrideStyles);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var styles = this._getStyles();

            var scrollBarStyles = '\n            .' + this._randomClassName + '::-webkit-scrollbar{\n                display:none;\n            }\n        ';

            //根据环境判断是否需要自己实现滚动条效果, 安卓4.0中, webkit-overflow-scrolling:touch 没有显示滚动条
            var scrollBar = undefined;
            if (!this._hasScrollBar) {
                scrollBar = '';
            } else {
                scrollBar = _react2.default.createElement(_ScrollBar2.default, {
                    ref: 'scrollBar'
                });
            }

            return _react2.default.createElement(
                'div',
                {
                    ref: 'domNode',
                    style: styles,
                    onScroll: function onScroll() {
                        return _this3._eventHandler.scroll();
                    },
                    onTouchStart: this._eventHandler.touchStart,
                    onTouchEnd: this._eventHandler.touchEnd,
                    className: this._randomClassName
                },
                this.props.children,
                _react2.default.createElement(
                    'style',
                    null,
                    scrollBarStyles
                ),
                scrollBar
            );
        }
    }]);

    return ScrollerBase;
}(_react2.default.Component);

ScrollerBase.propTypes = {
    onScroll: _react2.default.PropTypes.func
};
ScrollerBase.defaultProps = {
    onScroll: function onScroll() {},
    onReachTop: function onReachTop() {},
    onLeaveTop: function onLeaveTop() {},
    onReachBottom: function onReachBottom() {},
    onLeaveBottom: function onLeaveBottom() {}

};
exports.default = ScrollerBase;