'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _props2 = require('../common/props');

var _constant = require('../common/constant');

var _Refresher = require('../common/Refresher');

var _Refresher2 = _interopRequireDefault(_Refresher);

var _ScrollerBase = require('./ScrollerBase');

var _ScrollerBase2 = _interopRequireDefault(_ScrollerBase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by TonyJiang on 16/5/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

//工具


//子组件


var WrapperForNative = function (_React$Component) {
    _inherits(WrapperForNative, _React$Component);

    function WrapperForNative() {
        var _ref, _reach;

        var _temp, _this, _ret;

        _classCallCheck(this, WrapperForNative);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WrapperForNative.__proto__ || Object.getPrototypeOf(WrapperForNative)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            reach: (_reach = {}, _defineProperty(_reach, _constant.SIDE.TOP, false), _defineProperty(_reach, _constant.SIDE.BOTTOM, false), _reach),

            enableRefresh: false,
            enableLoadMore: false,

            //使用window监听事件后, 需要判断当前是否处于活跃状态
            isPress: false,

            //在_initDynamicState中定义
            status: undefined,
            isReach: undefined,
            springConstant: undefined
        }, _this._stateInShadow = {
            status: undefined
        }, _this._eventHandler = {
            dragStart: function dragStart(event) {
                if (!_this._checkInComponents(_this.refs.domNode, event.target)) {
                    return;
                }

                var pageY = event.touches[0].pageY;

                _this.state.deltaY = pageY;

                _this.state.isPress = true;

                if (_this.state.isReach) {
                    _this.state.startDeltaY = pageY;
                }
            },

            /**
             * 安卓:
             *  使用touchmove来计算移动距离
             */
            dragMoveAndroid: function dragMoveAndroid(event) {
                if (!_this.state.isPress) {
                    return;
                }

                if (!_this.state.isReach || _this.state.status == _constant.STATUS.DOING) {
                    return;
                }

                var pageY = event.touches[0].pageY;

                _this.state.deltaY = pageY;

                /**
                 * reachTopFirstRunner:
                 *      当屏幕滚动速度过快时, 两次touchmove事件之间的y轴高度差值较大,
                 *      会导致当reachTop触发后,下一个touchmove的y轴产生跳屏的现象,
                 *      所以当reachTop触发后的第一个touchmove事件才真正被认为是startDeltaY,
                 *      从而解决跳屏问题;
                 */
                if (_this.state.reachFirstRunner) {
                    _this.state.reachFirstRunner = false;
                    _this.state.startDeltaY = pageY;
                }

                var deltaY = (pageY - _this.state.startDeltaY) / _this.state.springConstant;
                // console.log('move deltaY', pageY, this.state.startDeltaY);

                _this.state.direction = deltaY > 0 ? _constant.DIRECTION.DOWN : _constant.DIRECTION.UP;

                // console.log('deltaY' , deltaY);
                //如果没有到顶并且下拉了, 说明此时内容中又滚动条, 所以不进行移动
                if (!_this.state.reach[_constant.SIDE.TOP] && deltaY > 0 || !_this.state.reach[_constant.SIDE.BOTTOM] && deltaY < 0) {
                    return;
                }

                event.preventDefault();
                event.stopPropagation();

                _this._scrollTo(0, deltaY);

                if (Math.abs(deltaY) > _this.props.distanceToRefresh) {
                    if (_this.state.status != _constant.STATUS.TRIGGER) {
                        _this.state.status = _constant.STATUS.TRIGGER;
                    }
                } else {
                    if (_this.state.status != _constant.STATUS.INITIAL) {
                        _this.state.status = _constant.STATUS.INITIAL;
                    }
                }
            },

            /**
             * IOS:
             *  使用系统原生scroll事件来计算移动距离(设置内容的height超过100%来保证任何时候都有滚动条)
             */
            dragMoveIOS: function dragMoveIOS() {
                if (!_this.state.isPress) {
                    return;
                }
                // console.log(this.state.scrollData);
                var _this$state$scrollDat = _this.state.scrollData,
                    scrollTop = _this$state$scrollDat.scrollTop,
                    offsetHeight = _this$state$scrollDat.offsetHeight,
                    scrollHeight = _this$state$scrollDat.scrollHeight;


                if (!_this.state.isReach || _this.state.status == _constant.STATUS.DOING) {
                    return;
                }

                var deltaY = undefined;
                //当已经到达内容顶部并继续往下拖拽时
                if (scrollTop < 0) {
                    deltaY = scrollTop / _this.state.springConstant;
                    _this.state.direction = _constant.DIRECTION.DOWN;

                    //当已经到达内容底部并继续往上拖拽时
                } else if (scrollTop + offsetHeight > scrollHeight) {
                    deltaY = (scrollTop + offsetHeight - scrollHeight) / _this.state.springConstant;
                    _this.state.direction = _constant.DIRECTION.UP;
                }

                if (Math.abs(deltaY) > _this.props.distanceToRefresh) {
                    if (_this.state.status != _constant.STATUS.TRIGGER) {
                        _this.state.status = _constant.STATUS.TRIGGER;
                    }
                } else {
                    if (_this.state.status != _constant.STATUS.INITIAL) {
                        _this.state.status = _constant.STATUS.INITIAL;
                    }
                }
            },

            dragEnd: function dragEnd() {
                var _triggerLine, _handler;

                if (!_this.state.isPress) {
                    return;
                }

                _this.state.isPress = false;

                if (_this.state.status == _constant.STATUS.DOING) {
                    return;
                }

                var _this$props = _this.props,
                    distanceToRefresh = _this$props.distanceToRefresh,
                    refreshHandler = _this$props.refreshHandler,
                    moreHandler = _this$props.moreHandler,
                    loadingMinTime = _this$props.loadingMinTime;


                var triggerLine = (_triggerLine = {}, _defineProperty(_triggerLine, _constant.DIRECTION.DOWN, distanceToRefresh), _defineProperty(_triggerLine, _constant.DIRECTION.UP, 0 - distanceToRefresh), _triggerLine);

                var handler = (_handler = {}, _defineProperty(_handler, _constant.DIRECTION.DOWN, refreshHandler), _defineProperty(_handler, _constant.DIRECTION.UP, moreHandler), _handler);

                var targetDeltaY = 0;

                if (_this.state.status == _constant.STATUS.TRIGGER) {

                    var actionHandler = undefined;
                    var canDo = _this.state.direction == _constant.DIRECTION.DOWN ? _this.state.enableRefresh : _this.state.enableLoadMore;

                    if (canDo) {
                        targetDeltaY = triggerLine[_this.state.direction];
                        actionHandler = handler[_this.state.direction];

                        _this.state.status = _constant.STATUS.DOING;
                        setTimeout(function () {
                            actionHandler(_this._completeAnimation.bind(_this));
                        }, loadingMinTime);
                    }
                } else {
                    //ios下,弹性滚动自动还原
                    // console.log('不刷新,还原');
                }

                _this._scrollTo(0, targetDeltaY, 400);
            },

            scroll: function scroll(event) {
                // console.log('scrollHandler');
                _this.state.scrollData = event;
                if (_this.props.scrollHandler) {
                    _this.props.scrollHandler(event);
                }
            },

            //滚动达到边缘的处理事件
            reach: function reach(type) {
                _this.state.reach[type] = true;
                _this.state.reachFirstRunner = true;

                _this.state.startDeltaY = _this.state.deltaY;
            },

            //滚动离开边缘的处理事件
            leave: function leave(type) {
                _this.state.reach[type] = false;
                //如果是安卓,移动速度过快时,需要在leave时重置位置
                if (_this.state.status != _constant.STATUS.DOING) {
                    _this._scrollTo(0, 0);
                }
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(WrapperForNative, [{
        key: 'componentWillMount',


        //根据props中事件监听, 判断是否启用refresh和loadMore
        value: function componentWillMount() {
            this._checkEnable(this.props);
        }

        //根据props中事件监听, 判断是否启用refresh和loadMore

    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            this._checkEnable(newProps);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._initDynamicState();
            this._initEvent();
        }
    }, {
        key: '_checkEnable',
        value: function _checkEnable(props) {
            this.state.enableRefresh = props.hasOwnProperty('refreshHandler') && typeof props.refreshHandler == 'function';
            this.state.enableLoadMore = props.hasOwnProperty('moreHandler') && typeof props.moreHandler == 'function';
        }
    }, {
        key: '_checkInComponents',
        value: function _checkInComponents(parent, child) {
            var dom = child;
            while (dom !== null) {
                if (dom == parent) {
                    return true;
                } else {
                    dom = dom.parentNode;
                }
            }
            return false;
        }
    }, {
        key: '_getStyles',
        value: function _getStyles() {
            var _props = this.props,
                displayWidth = _props.displayWidth,
                displayHeight = _props.displayHeight,
                style = _props.style,
                refreshColor = _props.refreshColor,
                moreColor = _props.moreColor,
                contentBackgroundColor = _props.contentBackgroundColor,
                rootBackgroundColor = _props.rootBackgroundColor;


            var styles = {

                root: Object.assign({
                    position: 'relative',
                    width: displayWidth,
                    height: displayHeight,
                    overflowY: 'hidden',
                    background: rootBackgroundColor
                }, style || {}),

                refresh: {
                    color: refreshColor
                },

                more: {
                    color: moreColor
                },

                scrollerWrapper: {
                    position: 'absolute',
                    top: 0,
                    left: 0,
                    right: 0,
                    bottom: 0,
                    zIndex: 2,
                    overflow: 'hidden',
                    background: contentBackgroundColor
                },

                contentWrapper: {
                    minHeight: mutants.env.os == mutants.env.constant.os.ios ? '100.2%' : '100%'
                }

            };

            return styles;
        }

        /**
         * 定义动态state
         * 为了解决组件状态发生改变时,不想触发自己的render,但是想要改变子组件的状态.
         * 通过PropertySetter来调用子组件改变对应状态的方法.
         */

    }, {
        key: '_initDynamicState',
        value: function _initDynamicState() {
            var _this2 = this;

            //定义state.status
            Object.defineProperty(this.state, 'status', {
                get: function get() {
                    return _this2._stateInShadow.status;
                },
                set: function set(value) {
                    if (_this2._stateInShadow.status != value) {
                        _this2._stateInShadow.status = value;

                        //根据拖拽方向判断当前更新的状态
                        var refresher = _this2.state.direction == _constant.DIRECTION.DOWN ? _this2.refs.header : _this2.refs.bottom;
                        var enable = _this2.state.direction == _constant.DIRECTION.DOWN ? _this2.state.enableRefresh : _this2.state.enableLoadMore;

                        if (enable) {
                            //更新子组件的状态
                            refresher.updateStatus(_this2._stateInShadow.status);
                        }
                    }
                }
            });

            //定义isReach
            Object.defineProperty(this.state, 'isReach', {
                get: function get() {
                    return _this2.state.reach[_constant.SIDE.TOP] || _this2.state.reach[_constant.SIDE.BOTTOM];
                }
            });

            //定义弹性
            Object.defineProperty(this.state, 'springConstant', {
                value: mutants.env.os == mutants.env.constant.os.ios ? 1 : this.props.resistance
            });
        }

        //事件处理

    }, {
        key: 'scrollTo',


        //提供对外滚动方法
        value: function scrollTo(deltaY) {
            var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

            this.refs.scroller.scrollTo(deltaY, duration);
        }
    }, {
        key: '_scrollTo',
        value: function _scrollTo() {
            var deltaX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
            var deltaY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
            var duration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

            var dom = this.refs.scrollerWrapper;

            //设置时间
            dom.style['-webkit-transition-duration'] = dom.style['transition-duration'] = duration + 'ms';
            //设置位移
            dom.style['-webkit-transform'] = dom.style['transform'] = 'translate3d(' + deltaX + 'px,' + deltaY + 'px, 0px)';
        }
    }, {
        key: '_completeAnimation',
        value: function _completeAnimation() {
            //还原refresh状态
            if (this.state.status == _constant.STATUS.DOING) {
                this.state.status = _constant.STATUS.INITIAL;
                this._scrollTo(0, 0, 400);
            }
        }

        //绑定事件

    }, {
        key: '_initEvent',
        value: function _initEvent() {
            var _mutants = mutants,
                env = _mutants.env;
            //根据当前的环境判断处理方式

            var dragMoveHandler = env.os == env.constant.os.ios ? this._eventHandler.dragMoveIOS : this._eventHandler.dragMoveAndroid;

            // this.refs.domNode.addEventListener('touchstart' , this._eventHandler.dragStart , true);
            // this.refs.domNode.addEventListener('touchmove' , dragMoveHandler.bind(this) , true);
            // this.refs.domNode.addEventListener('touchend' , this._eventHandler.dragEnd , true);

            //改为使用window监听事件, 只有当事件在当前domNode内, 才会进行后续操作, 这样修改是为了兼容其他第三方类库, 比如客户管家中的侧拉;
            //不再在捕获阶段进行事件监听, 改为冒泡阶段, 防止阻止冒泡导致其他类库无法监听事件;
            window.addEventListener('touchstart', this._eventHandler.dragStart);
            window.addEventListener('touchmove', dragMoveHandler.bind(this));
            window.addEventListener('touchend', this._eventHandler.dragEnd);
        }
    }, {
        key: 'render',
        value: function render() {
            var styles = this._getStyles();

            var refreshLoading = _react2.default.createElement(_Refresher2.default, {
                ref: 'header',
                style: { position: 'absolute', top: 0 },
                enable: this.state.enableRefresh,
                loadingMinTime: this.props.loadingMinTime,
                type: this.props.loadingStyle,
                distanceToRefresh: this.props.distanceToRefresh,
                statusLabel: this.props.refreshStatusLabel,
                direction: _constant.DIRECTION.DOWN,
                color: styles.refresh.color,
                status: this.state.status
            });

            var content = _react2.default.createElement(
                'div',
                { ref: 'scrollerWrapper', style: styles.scrollerWrapper },
                _react2.default.createElement(
                    _ScrollerBase2.default,
                    {
                        ref: 'scroller',
                        onScroll: this._eventHandler.scroll,
                        onReachTop: this._eventHandler.reach.bind(this, _constant.SIDE.TOP),
                        onLeaveTop: this._eventHandler.leave.bind(this, _constant.SIDE.TOP),
                        onReachBottom: this._eventHandler.reach.bind(this, _constant.SIDE.BOTTOM),
                        onLeaveBottom: this._eventHandler.leave.bind(this, _constant.SIDE.BOTTOM)
                    },
                    _react2.default.createElement(
                        'div',
                        { style: styles.contentWrapper },
                        this.props.children
                    )
                )
            );

            var moreLoading = _react2.default.createElement(_Refresher2.default, {
                ref: 'bottom',
                style: { position: 'absolute', bottom: 0 },
                enable: this.state.enableLoadMore,
                loadingMinTime: this.props.loadingMinTime,
                type: this.props.loadingStyle,
                distanceToRefresh: this.props.distanceToRefresh,
                statusLabel: this.props.moreStatusLabel,
                direction: _constant.DIRECTION.UP,
                color: styles.more.color,
                status: this.state.moreStatus
            });

            return _react2.default.createElement(
                'div',
                { ref: 'domNode', style: styles.root },
                refreshLoading,
                content,
                moreLoading
            );
        }
    }]);

    return WrapperForNative;
}(_react2.default.Component);

WrapperForNative.propTypes = _props2.propTypes;
WrapperForNative.defaultProps = _props2.defaultProps;
exports.default = WrapperForNative;