'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _constant = require('../common/constant');

var _props = require('../common/props');

var _Refresher = require('../common/Refresher');

var _Refresher2 = _interopRequireDefault(_Refresher);

var _ScrollBar = require('../common/ScrollBar');

var _ScrollBar2 = _interopRequireDefault(_ScrollBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by TonyJiang on 16/3/29.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


function getStyles(props, context) {
    var displayWidth = props.displayWidth,
        displayHeight = props.displayHeight,
        refreshColor = props.refreshColor,
        moreColor = props.moreColor,
        contentBackgroundColor = props.contentBackgroundColor,
        rootBackgroundColor = props.rootBackgroundColor;


    var rootStyle = {
        position: 'relative',
        width: displayWidth,
        height: displayHeight,
        overflow: 'hidden',
        background: rootBackgroundColor
    };

    return {

        root: Object.assign({}, rootStyle, props.style || {}),

        refresh: {
            color: refreshColor
        },

        more: {
            color: moreColor
        },

        content: {
            position: 'absolute',
            top: 0,
            width: '100%',
            minHeight: '100%',
            zIndex: 2,
            background: contentBackgroundColor,
            overflowX: 'hidden',
            overflowY: 'auto',
            transitionDuration: '0ms',
            transitionTimingFunction: 'cubic-bezier(0.165, 0.84, 0.44, 1)',
            transform: 'translate3d(0px , ' + props.deltaY + 'px , 0px)'
        },

        fixKeyboardJumpTop: {
            position: 'absolute',
            width: '100%',
            left: 0,
            top: '-1px',
            height: '2px',
            zIndex: -1,
            background: contentBackgroundColor
        },

        fixKeyboardJumpBottom: {
            position: 'absolute',
            width: '100%',
            left: 0,
            bottom: '-1px',
            height: '2px',
            zIndex: -1,
            background: contentBackgroundColor
        }

    };
}

var cubic = {

    //超出边界减速
    quadratic: 'cubic-bezier(0.25, 0.46, 0.45, 0.94)',

    //回弹曲线
    outCirc: 'cubic-bezier(0.075, 0.82, 0.165, 1)',

    //惯性曲线
    outCubic: 'cubic-bezier(0.165, 0.84, 0.44, 1)',

    easeOutBack: 'cubic-bezier(0.175, 0.885, 0.32, 1.275)',

    easeFastOutBack: 'cubic-bezier(0.625, 0.3, 0.95, 0.245)',

    //常规曲线
    circular: 'cubic-bezier(0.1, 0.57, 0.1, 1)'
};

var tools = {
    translateMatrixRE: /matrix(3d)?\((.+?)\)/,
    parseTranslateMatrix: function parseTranslateMatrix(translateString, position) {
        if (!translateString) {
            return { x: 0, y: 0, z: 0 };
        }
        var matrix = translateString.match(this.translateMatrixRE);
        var is3D = matrix && matrix[1];
        if (matrix) {
            matrix = matrix[2].split(",");
            if (is3D === "3d") matrix = matrix.slice(12, 15);else {
                matrix.push(0);
                matrix = matrix.slice(4, 7);
            }
        } else {
            matrix = [0, 0, 0];
        }
        var result = {
            x: parseFloat(matrix[0]),
            y: parseFloat(matrix[1]),
            z: parseFloat(matrix[2])
        };
        if (position && result.hasOwnProperty(position)) {
            return result[position];
        }
        return result;
    }
};

/**
 *  列表组件
 *  实现以下功能:
 *      1.顶部下拉刷新
 *      2.尾部下拉加载更多
 *      3.支持手势惯性效果
 *      4.支持回弹效果
 *
 *  @extends React.Component
 */

var WrapperForSimulate = function (_React$Component) {
    _inherits(WrapperForSimulate, _React$Component);

    //计算速度


    //dom指针


    /**
     *@member props {JSONObject} 接受设置参数
     *@memberOf LoadMoreList.prototype
     */
    function WrapperForSimulate(props, context) {
        var _enable, _reach;

        _classCallCheck(this, WrapperForSimulate);

        var _this = _possibleConstructorReturn(this, (WrapperForSimulate.__proto__ || Object.getPrototypeOf(WrapperForSimulate)).call(this, props, context));

        _this.state = {

            enable: (_enable = {}, _defineProperty(_enable, _constant.SIDE.TOP, false), _defineProperty(_enable, _constant.SIDE.BOTTOM, false), _enable),

            reach: (_reach = {}, _defineProperty(_reach, _constant.SIDE.TOP, false), _defineProperty(_reach, _constant.SIDE.BOTTOM, false), _reach),

            status: undefined,
            refreshSide: null
        };
        _this._stateInShadow = {
            status: undefined
        };
        _this._state = {};
        _this._deltaY = 0;
        _this._lastDeltaY = 0;
        _this._reachSideDeltaY = 0;
        _this.domRefs = {};
        _this._checkOutOfRangeTimer = 0;
        _this._velocityTimer = 0;
        _this._durationEventTrigger = 0;
        _this._method = {

            //在手指移动时, 进行滚动
            animateFrame: function animateFrame() {
                if (!_this._state.press) {
                    window.cancelAnimationFrame(_this._requestAnimationId);
                    return;
                }

                if (_this._deltaY != _this._state.lastAnimateDeltaY) {
                    _this._method.scrollTo(0, _this._deltaY);
                    _this._state.lastAnimateDeltaY = _this._deltaY;
                }

                _this._requestAnimationId = window.requestAnimationFrame(_this._method.animateFrame.bind(_this));
            },

            //计算速度
            computeVelocity: function computeVelocity() {

                //当用户快速移动并停止一段时间后,松手依旧会触发惯性,是因为没有计算松手时间, 在这里重新更新时间戳, 保证速度计算正确
                //防止在timer间隙的时候计算速度, 导致没有获取到当前时间
                if (_this._state.timestamp == _this._state.lastTime) {
                    _this._state.timestamp = Date.now();
                }

                //滑动时间
                var deltaTime = _this._state.timestamp - _this._state.lastTime;
                _this._state.lastTime = _this._state.timestamp;
                //滑动距离
                var deltaY = _this._state.pageY - _this._state.lastPageY;
                _this._state.lastPageY = _this._state.pageY;

                if (deltaTime == 0 && deltaY == 0) {
                    _this._state.velocity = 0;
                } else {
                    //保证最小时间为10ms
                    deltaTime = Math.max(10, deltaTime);
                    //根据路程求出阻尼系数
                    var speedResistance = Math.min(Math.abs(deltaY / 180), 1);
                    //速度
                    _this._state.velocity = deltaY / deltaTime * speedResistance;
                }
            },

            //计算惯性移动
            doInertial: function doInertial(speed) {

                //0.005以内的惯性,忽略不计,小步长移动速度大概在0.005上下, 更贴近ios效果
                if (!speed || speed < 0.002 && speed > -0.002) {
                    return false;
                }

                var _speed = 0;

                var _maxSpeed = 2.0;

                //设置最大速度为0.8 , 避免出现速度过快导致闪屏的问题
                if (speed > 0) {
                    _speed = Math.min(speed, _maxSpeed);
                } else {
                    _speed = Math.max(speed, -_maxSpeed);
                }

                var speedResistance = Math.min(Math.abs(_speed / 4), 1);

                var time = 1800 + 1000 * speedResistance;
                var a = -_speed / time;

                var distance = _speed * time + a * time * time / 2;

                _this.state.inertialDistance = distance;

                distance += _this._deltaY;

                var _this$_method$outOfSc = _this._method.outOfScreen(distance, time),
                    deltaY = _this$_method$outOfSc.deltaY,
                    ease = _this$_method$outOfSc.ease,
                    duration = _this$_method$outOfSc.duration;

                _this._method.scrollTo(0, deltaY, duration, true, ease);

                return true;
            },

            //判断当前的滚动目标位置是否超出显示范围
            outOfScreen: function outOfScreen(deltaY) {
                var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;


                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                var topLine = _this.state.direction == _constant.DIRECTION.DOWN && _this.state.status == _constant.STATUS.DOING ? _this.props.distanceToRefresh : 0;

                //如果内容超过视图,maxheight为差值,如果内容小于视图,那直接就应该有阻尼
                var bottomLine = contentHeight > clientHeight ? contentHeight - clientHeight : 0;

                var _deltaY = void 0,
                    _duration = void 0,
                    _ease = void 0;

                if (deltaY >= topLine) {
                    _deltaY = topLine;
                    // _duration = duration * (this._deltaY - _deltaY) / (this._deltaY - deltaY);
                    _duration = 600;
                    _ease = cubic.outCubic; //cubic.easeOutBack;
                } else if (deltaY <= -bottomLine) {
                    _deltaY = -bottomLine;
                    _duration = 600;
                    // _duration = duration * (this._deltaY - _deltaY) / (this._deltaY - deltaY);
                    _ease = cubic.outCubic; //cubic.easeOutBack;
                } else {
                    _deltaY = deltaY;
                    _duration = duration;
                    _ease = cubic.outCubic;
                }

                return { deltaY: _deltaY, duration: Math.abs(_duration), ease: _ease };
            },

            //移动到指定位置
            scrollTo: function scrollTo() {
                var deltaX = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
                var deltaY = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
                var duration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
                var isInertial = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
                var ease = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : cubic.outCubic;

                var _this$_method$getTrig = _this._method.getTriggerLine(),
                    clientHeight = _this$_method$getTrig.clientHeight,
                    contentHeight = _this$_method$getTrig.contentHeight,
                    topLine = _this$_method$getTrig.topLine,
                    bottomLine = _this$_method$getTrig.bottomLine;

                if (deltaY > topLine || deltaY < bottomLine) {
                    ease = cubic.quadratic;
                }

                var dom = _this.domRefs.list;

                var cssText = ['-webkit-transition-timing-function:', ease, ';', 'transition-timing-function:', ease, ';', '-webkit-transition-duration:', duration, 'ms;', 'transition-duration:', duration, 'ms;', '-webkit-transform:', 'translate3d(' + deltaX + 'px,' + deltaY + 'px, 0px);', 'transform:', 'translate3d(' + deltaX + 'px,' + deltaY + 'px, 0px);'].join('');

                dom.style.cssText = dom.style.cssText + cssText;

                _this._method.stopInertialTimer();

                if (isInertial) {
                    //在惯性移动中,模拟移动事件
                    _this._method.startInertialTimer(duration);
                }

                _this._method.updateScrollBar();

                if (!isInertial) {
                    _this._eventHandler.scroll({
                        scrollTop: parseInt(-deltaY),
                        offsetHeight: clientHeight,
                        scrollHeight: contentHeight,
                        press: _this._state.press
                    });
                }
            },

            //移动模拟滚动条位置
            updateScrollBar: function updateScrollBar(y) {

                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                var scrollBar = _this.refs.scrollBar;


                var deltaY = y ? y : _this._deltaY;

                if (deltaY > 0) {
                    return;
                }

                scrollBar.show();
                scrollBar.scrollTo({ deltaY: deltaY, contentHeight: contentHeight, clientHeight: clientHeight });

                if (!_this._state.press) {
                    clearTimeout(_this._hideScrollbarUI);
                    _this._hideScrollbarUI = setTimeout(function () {
                        scrollBar.hide();
                    }, 500);
                }
            },

            //在惯性移动过程中, 按60帧的速率, 模拟滚动事件
            startInertialTimer: function startInertialTimer(duration) {

                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                if (_this._durationEventTrigger) {
                    clearInterval(_this._durationEventTrigger);
                    _this._durationEventTrigger = 0;
                }

                //按照40帧的速度进行时间模拟(实际不会达到40帧)
                _this._durationEventTrigger = setInterval(function () {
                    var matrix = tools.parseTranslateMatrix(window.getComputedStyle(_this.domRefs.list).webkitTransform);

                    //toFixed是为了防止出现 -1.57565e-7 这样的数字
                    _this._deltaY = parseFloat(matrix.y.toFixed(2));

                    _this._eventHandler.scroll({
                        scrollTop: parseInt(-_this._deltaY),
                        offsetHeight: clientHeight,
                        scrollHeight: contentHeight,
                        press: _this._state.press
                    });

                    _this._method.updateScrollBar();
                }, 25);

                //独立使用一个timeout , 保证duration之后 , 肯定会被clear;
                _this._clearDurationEventTriggerTimeout = setTimeout(function () {
                    // console.log('clear interval');
                    clearInterval(_this._durationEventTrigger);
                }, duration);
            },

            //停止模拟惯性事件
            stopInertialTimer: function stopInertialTimer() {
                if (_this._durationEventTrigger) {
                    clearInterval(_this._durationEventTrigger);
                    _this._durationEventTrigger = 0;
                }
                if (_this._clearDurationEventTriggerTimeout) {
                    clearTimeout(_this._clearDurationEventTriggerTimeout);
                    _this._clearDurationEventTriggerTimeout = 0;
                }
            },

            //计算触发刷新的位置
            getTriggerLine: function getTriggerLine() {
                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                //定义顶部位置 , 顶部触发位置 , 底部位置 ,底部触发位置
                var topLine = _this.state.status == _constant.STATUS.DOING && _this.state.direction == _constant.DIRECTION.DOWN ? _this.props.distanceToRefresh : 0;
                var topTriggerLine = _this.props.distanceToRefresh;
                var bottomLine = contentHeight >= clientHeight ? -(contentHeight - clientHeight) : 0;
                var bottomTriggerLine = bottomLine - _this.props.distanceToRefresh;

                return { clientHeight: clientHeight, contentHeight: contentHeight, topLine: topLine, topTriggerLine: topTriggerLine, bottomLine: bottomLine, bottomTriggerLine: bottomTriggerLine };
            },

            //检测是否需要 刷新/加载更多 的操作
            checkLoadWhenDragEnd: function checkLoadWhenDragEnd() {
                var _line, _triggerLine, _handler, _direction;

                if (!_this.state.isReach) {
                    return;
                }

                var _this$props = _this.props,
                    distanceToRefresh = _this$props.distanceToRefresh,
                    refreshHandler = _this$props.refreshHandler,
                    moreHandler = _this$props.moreHandler,
                    loadingMinTime = _this$props.loadingMinTime;
                var refreshSide = _this.state.refreshSide;

                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                var topLine = 0;
                var topTriggerLine = _this.props.distanceToRefresh;
                var bottomLine = contentHeight >= clientHeight ? -(contentHeight - clientHeight) : 0;
                var bottomTriggerLine = bottomLine - distanceToRefresh;

                //边线
                var line = (_line = {}, _defineProperty(_line, _constant.SIDE.TOP, topLine), _defineProperty(_line, _constant.SIDE.BOTTOM, bottomLine), _line);

                //触发线
                var triggerLine = (_triggerLine = {}, _defineProperty(_triggerLine, _constant.SIDE.TOP, topTriggerLine), _defineProperty(_triggerLine, _constant.SIDE.BOTTOM, bottomTriggerLine), _triggerLine);

                //回调函数
                var handler = (_handler = {}, _defineProperty(_handler, _constant.SIDE.TOP, refreshHandler), _defineProperty(_handler, _constant.SIDE.BOTTOM, moreHandler), _handler);

                //拖拽方向
                var direction = (_direction = {}, _defineProperty(_direction, _constant.SIDE.TOP, _constant.DIRECTION.DOWN), _defineProperty(_direction, _constant.SIDE.BOTTOM, _constant.DIRECTION.UP), _direction);

                var targetDeltaY = 0;

                //当前状态处于触发状态
                if (_this.state.status == _constant.STATUS.TRIGGER) {

                    var actionHandler = undefined;
                    //判断是否可以进行对应的刷新操作
                    var canDo = refreshSide && _this.state.reach[refreshSide] && _this.state.enable[refreshSide] && _this.state.direction == direction[refreshSide];

                    if (canDo) {

                        targetDeltaY = triggerLine[refreshSide];
                        actionHandler = handler[refreshSide];

                        _this.state.status = _constant.STATUS.DOING;

                        setTimeout(function () {
                            actionHandler(_this.completeAnimation.bind(_this));
                        }, loadingMinTime);
                    } else {

                        targetDeltaY = line[refreshSide];
                    }

                    //如果在加载中, 则不做任何处理, 否则可能影响当前正在进行的动画
                } else if (_this.state.status == _constant.STATUS.DOING) {

                    return;
                    // targetDeltaY = triggerLine[this.state.refreshSide];

                    //到达边界, 但是又不够触发距离, 则应该弹回对应的顶部
                } else {

                    targetDeltaY = line[refreshSide];
                }

                _this._deltaY = targetDeltaY;
                _this._method.scrollTo(0, targetDeltaY, 400);
            },

            //检测事件是否触发在当前组件上, 由于dragStart绑定在body上, 所以需要检测事件范围
            checkEventInThis: function checkEventInThis(target) {
                var _target = target;
                while (_target) {
                    if (_target == _this.domRefs.domNode) {
                        return true;
                    } else {
                        _target = _target.parentNode;
                    }
                }
                return false;
            },

            startCheckOutOfRangeTimer: function startCheckOutOfRangeTimer() {
                _this._checkOutOfRangeTimer = setInterval(function () {

                    _this._method.checkOutOfRange();
                }, 16.7);
            },

            stopCheckOutOfRangeTimer: function stopCheckOutOfRangeTimer() {
                clearInterval(_this._checkOutOfRangeTimer);
            },

            //检测
            checkOutOfRange: function checkOutOfRange() {
                // console.log('check out of range');

                //如果用户正在交互, 不做任何处理
                if (_this._state.press) {
                    return;
                }

                var clientHeight = _this.domRefs.domNode.clientHeight;
                var contentHeight = _this.domRefs.list.clientHeight;

                // console.log('clientHeight', clientHeight, 'contentHeight', contentHeight);
                if (contentHeight < clientHeight) {
                    return;
                }

                var computeScrollTop = contentHeight - clientHeight;

                //如果内容底部不够到达边界, 则需要往上滚动调整到边界处;
                if (computeScrollTop < Math.abs(_this._deltaY) && _this.state.status != _constant.STATUS.DOING) {
                    _this._deltaY = -computeScrollTop;
                    //如果当前是处于边界状态, 需要将_reachSideDeltaY同时更新, 保证后续的回弹位置正确
                    //2016-11-13 只有在reachBottom时, 才需要设置, 如果是顶部内容不够, 不用更新_reachSideDeltaY
                    // if(this.state.reach[SIDE.TOP] || this.state.reach[SIDE.BOTTOM]){
                    if (_this.state.reach[_constant.SIDE.BOTTOM] && !_this.state.reach[_constant.SIDE.TOP]) {
                        _this._reachSideDeltaY = -computeScrollTop;
                    }
                    _this._method.scrollTo(0, _this._deltaY);
                }
            }

        };
        _this._eventHandler = {
            //手指按下
            dragStart: function dragStart(event) {

                //判断事件在当前组件上
                if (!_this._method.checkEventInThis(event.target)) {
                    return;
                }

                //停止惯性 , 并在当前位置停住
                _this._method.stopInertialTimer();

                var _window$getComputedSt = window.getComputedStyle(_this.domRefs.list),
                    transform = _window$getComputedSt.transform,
                    webkitTransform = _window$getComputedSt.webkitTransform;

                var matrix = tools.parseTranslateMatrix(transform || webkitTransform);
                _this._deltaY = matrix.y;
                _this._method.scrollTo(matrix.x, matrix.y, 0);

                //手指按下时, 记录当前的初始位置,时间等数据.
                var pageY = event.touches[0].pageY;


                _this._lastDeltaY = _this._deltaY;
                _this._startPageY = pageY;

                _this._state.press = true;
                _this._state.timestamp = Date.now();
                _this._state.lastTime = _this._state.timestamp;
                _this._state.velocity = 0;
                _this._state.pageY = pageY;
                _this._state.lastPageY = pageY;

                _this._velocityTimer = setInterval(_this._method.computeVelocity.bind(_this), 10);

                _this._requestAnimationId = window.requestAnimationFrame(_this._method.animateFrame.bind(_this));

                _this.refs.scrollBar.show();
            },

            //手指移动
            dragMove: function dragMove(e) {
                e.preventDefault();

                var pageY = e.touches[0].pageY;

                var now = Date.now();

                var _this$_method$getTrig2 = _this._method.getTriggerLine(),
                    topLine = _this$_method$getTrig2.topLine,
                    bottomLine = _this$_method$getTrig2.bottomLine,
                    topTriggerLine = _this$_method$getTrig2.topTriggerLine,
                    bottomTriggerLine = _this$_method$getTrig2.bottomTriggerLine;

                _this._deltaY = _this._lastDeltaY + (pageY - _this._startPageY);

                _this.state.direction = pageY > _this._startPageY ? _constant.DIRECTION.DOWN : _constant.DIRECTION.UP;

                //代码移至滚动事件处理中
                // this.state.reach[SIDE.TOP] = this._deltaY >= topLine;
                // this.state.reach[SIDE.BOTTOM] = this._deltaY <= bottomLine;

                //到达边界后, 移动应该有阻尼效果
                if (_this.state.reach[_constant.SIDE.TOP] || _this.state.reach[_constant.SIDE.BOTTOM]) {
                    _this._deltaY = _this._reachSideDeltaY + (_this._deltaY - _this._reachSideDeltaY) / _this.props.resistance;
                }

                _this._state.pageY = pageY;
                _this._state.timestamp = now;

                if (_this.state.status == _constant.STATUS.DOING) {
                    return;
                }

                var triggerTop = _this.state.reach[_constant.SIDE.TOP] && _this._deltaY > topTriggerLine;
                var triggerBottom = _this.state.reach[_constant.SIDE.BOTTOM] && _this._deltaY < bottomTriggerLine;

                // console.log('move triggerTop' , triggerTop , 'triggerBottom' , triggerBottom);

                //顶部到达触发线并且启用
                if (triggerTop && _this.state.enable[_constant.SIDE.TOP]) {
                    _this.state.refreshSide = _constant.SIDE.TOP;

                    if (_this.state.status != _constant.STATUS.TRIGGER) {
                        _this.state.status = _constant.STATUS.TRIGGER;
                    }

                    //底部到达触发线并且启用
                } else if (triggerBottom && _this.state.enable[_constant.SIDE.BOTTOM]) {
                    _this.state.refreshSide = _constant.SIDE.BOTTOM;

                    if (_this.state.status != _constant.STATUS.TRIGGER) {
                        _this.state.status = _constant.STATUS.TRIGGER;
                    }
                } else {
                    // console.log('change to initial');
                    if (_this.state.status != _constant.STATUS.INITIAL) {
                        _this.state.status = _constant.STATUS.INITIAL;
                    }
                }
            },

            //手指抬起
            dragEnd: function dragEnd() {

                _this._state.press = false;

                window.cancelAnimationFrame(_this._requestAnimationId);
                clearInterval(_this._velocityTimer);

                //防止高频率小步长移动时, timer来不及计算速度就被停止;
                if (_this._state.velocity == 0) {
                    _this._method.computeVelocity();
                }

                //如果不做惯性,则抛出一次scrollTo事件
                if (!_this._method.doInertial(_this._state.velocity)) {
                    //抬起后再次出发scroll
                    _this._method.scrollTo(0, _this._deltaY);
                }

                //检测是否需要 刷新/加载更多 的操作
                _this._method.checkLoadWhenDragEnd();

                //清空速度
                _this._state.velocity = 0;

                //如果在顶部松手, 则需要充值reachSideDeltaY, 如果在底部, 清空会导致跳屏
                if (_this.state.reach[_constant.SIDE.TOP]) {
                    //清空到达边界的deltaY
                    _this._reachSideDeltaY = 0;
                }

                _this.refs.scrollBar.hide();
            },

            scroll: function scroll(event) {
                var scrollTop = event.scrollTop,
                    offsetHeight = event.offsetHeight,
                    scrollHeight = event.scrollHeight;

                var _this$_method$getTrig3 = _this._method.getTriggerLine(),
                    topLine = _this$_method$getTrig3.topLine,
                    bottomLine = _this$_method$getTrig3.bottomLine,
                    topTriggerLine = _this$_method$getTrig3.topTriggerLine,
                    bottomTriggerLine = _this$_method$getTrig3.bottomTriggerLine;

                //原来的处理顺序有问题, 当内容只比视窗大小大一点时, 会先触发另一边的reach , 才触发leave, 逻辑顺序错误


                if (scrollTop > topLine) {
                    if (_this.state.reach[_constant.SIDE.TOP]) {
                        _this.state.reach[_constant.SIDE.TOP] = false;
                        _this._eventHandler.leaveTop();
                    }
                }

                if (scrollTop + offsetHeight < scrollHeight) {
                    if (_this.state.reach[_constant.SIDE.BOTTOM]) {
                        _this.state.reach[_constant.SIDE.BOTTOM] = false;
                        _this._eventHandler.leaveBottom();
                    }
                }

                if (scrollTop <= topLine) {
                    if (!_this.state.reach[_constant.SIDE.TOP]) {
                        _this.state.reach[_constant.SIDE.TOP] = true;
                        _this._eventHandler.reachTop();
                    }
                }

                if (scrollTop + offsetHeight >= scrollHeight) {
                    if (!_this.state.reach[_constant.SIDE.BOTTOM]) {
                        _this.state.reach[_constant.SIDE.BOTTOM] = true;
                        _this._eventHandler.reachBottom();
                    }
                }

                // if(scrollTop <= topLine) {
                //     if(!this.state.reach[SIDE.TOP]){
                //         this.state.reach[SIDE.TOP] = true;
                //         this._eventHandler.reachTop();
                //     }
                // }else if(scrollTop + offsetHeight >= scrollHeight){
                //     if(!this.state.reach[SIDE.BOTTOM]){
                //         this.state.reach[SIDE.BOTTOM] = true;
                //         this._eventHandler.reachBottom();
                //     }
                // }else{
                //     if(this.state.reach[SIDE.TOP]){
                //         this.state.reach[SIDE.TOP] = false;
                //         this._eventHandler.leaveTop();
                //     }
                //
                //     if(this.state.reach[SIDE.BOTTOM]){
                //         this.state.reach[SIDE.BOTTOM] = false;
                //         this._eventHandler.leaveBottom();
                //     }
                //
                // }

                if (_this.props.scrollHandler) {
                    _this.props.scrollHandler(event);
                }
            },

            reachTop: function reachTop() {
                _this._reachSideDeltaY = _this._deltaY;
                _this.state.refreshSide = _constant.SIDE.TOP;
                _this.domRefs.headerRefresh.style.display = _this.state.enable[_constant.SIDE.TOP] ? 'block' : 'none';
            },

            leaveTop: function leaveTop() {
                _this._reachSideDeltaY = 0;
                _this.state.refreshSide = null;
                _this.domRefs.headerRefresh.style.display = 'none';
            },

            reachBottom: function reachBottom() {
                _this._reachSideDeltaY = _this._deltaY;
                _this.state.refreshSide = _constant.SIDE.BOTTOM;
                _this.domRefs.footerRefresh.style.display = _this.state.enable[_constant.SIDE.BOTTOM] ? 'block' : 'none';
            },

            leaveBottom: function leaveBottom() {
                _this._reachSideDeltaY = 0;
                _this.state.refreshSide = null;
                _this.domRefs.footerRefresh.style.display = 'none';
            }

        };


        _this._bindFunction();

        return _this;
    }

    //根据props中事件监听, 判断是否启用refresh和loadMore

    //模拟惯性滚动


    //timer

    //检测当前窗口内容是否显示够一屏, 不够需要往回滚动


    //Y轴相关


    _createClass(WrapperForSimulate, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this._checkEnable(this.props);
        }

        //根据props中事件监听, 判断是否启用refresh和loadMore

    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            this._checkEnable(newProps);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {

            this._initDomRefs();
            this._bindEvents();
            this._initDynamicState();
            this._method.startCheckOutOfRangeTimer();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._unbindEvents();
            this._method.stopCheckOutOfRangeTimer();
        }

        //重新渲染后,判断内容是否不够填满一屏,如果不够需要向上滚动

    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            var _this2 = this;

            //等待dom真正重新渲染完成
            window.requestAnimationFrame(function () {

                var clientHeight = _this2.domRefs.domNode.clientHeight;
                var contentHeight = _this2.domRefs.list.clientHeight;

                if (contentHeight < clientHeight) {
                    return;
                }

                var computeScrollTop = contentHeight - clientHeight;

                if (computeScrollTop < Math.abs(_this2._deltaY) && _this2.state.status != _constant.STATUS.DOING) {
                    _this2._deltaY = -computeScrollTop;
                    _this2._method.scrollTo(0, _this2._deltaY);
                }
            });
        }
    }, {
        key: '_bindFunction',
        value: function _bindFunction() {
            this._eventHandler.dragStart = this._eventHandler.dragStart.bind(this);
            this._eventHandler.dragMove = this._eventHandler.dragMove.bind(this);
            this._eventHandler.dragEnd = this._eventHandler.dragEnd.bind(this);
        }
    }, {
        key: '_checkEnable',
        value: function _checkEnable(props) {
            this.state.enable[_constant.SIDE.TOP] = props.hasOwnProperty('refreshHandler') && typeof props.refreshHandler == 'function';
            this.state.enable[_constant.SIDE.BOTTOM] = props.hasOwnProperty('moreHandler') && typeof props.moreHandler == 'function';
        }

        //通过dom绑定touchstart来解决material-ui阻止touchstart的问题

    }, {
        key: '_bindEvents',
        value: function _bindEvents() {
            this.domRefs.document.body.addEventListener('touchstart', this._eventHandler.dragStart);
        }

        //在组件即将被销毁的时候, 解绑body的事件

    }, {
        key: '_unbindEvents',
        value: function _unbindEvents() {
            this.domRefs.document.body.removeEventListener('touchstart', this._eventHandler.dragStart);
        }

        /**
         * 定义动态state
         * 为了解决组件状态发生改变时,不想触发自己的render,但是想要改变子组件的状态.
         * 通过PropertySetter来调用子组件改变对应状态的方法.
         */

    }, {
        key: '_initDynamicState',
        value: function _initDynamicState() {
            var _this3 = this;

            //定义state.status
            Object.defineProperty(this.state, 'status', {
                get: function get() {
                    return _this3._stateInShadow.status;
                },
                set: function set(value) {
                    if (_this3._stateInShadow.status != value) {
                        _this3._stateInShadow.status = value;

                        //根据拖拽方向判断当前更新的状态
                        var refresher = _this3.state.direction == _constant.DIRECTION.DOWN ? _this3.refs.header : _this3.refs.footer;
                        var enable = _this3.state.direction == _constant.DIRECTION.DOWN ? _this3.state.enable[_constant.SIDE.TOP] : _this3.state.enable[_constant.SIDE.BOTTOM];

                        if (enable) {
                            //更新子组件的状态
                            refresher.updateStatus(_this3._stateInShadow.status);
                        }
                    }
                }
            });

            //定义isReach
            Object.defineProperty(this.state, 'isReach', {
                get: function get() {
                    return _this3.state.reach[_constant.SIDE.TOP] || _this3.state.reach[_constant.SIDE.BOTTOM];
                }
            });

            //定义弹性
            Object.defineProperty(this.state, 'springConstant', {
                value: mutants.env.os == mutants.env.constant.os.ios ? 1 : this.props.resistance
            });
        }

        //当外部加载数据完成,调用这个方法重置动画状态

    }, {
        key: 'completeAnimation',
        value: function completeAnimation() {

            if (this.state.status == _constant.STATUS.DOING) {
                this.state.status = _constant.STATUS.INITIAL;
                //如果完成的时候, 顶部还贴边, 则进行回弹, 如果在过程中进行了滚动, refreshSide为null, 不做任何处理
                if (this.state.refreshSide == _constant.SIDE.TOP) {
                    this._method.scrollTo(0, 0, 400);
                }
            }
        }

        //提供对外滚动方法

    }, {
        key: 'scrollTo',
        value: function scrollTo(deltaY) {
            var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

            this._deltaY = deltaY;
            this._method.scrollTo(0, deltaY, duration);
        }

        //内部方法


        //事件处理

    }, {
        key: '_initDomRefs',


        //初始化dom指针
        value: function _initDomRefs() {

            this.domRefs.domNode = _reactDom2.default.findDOMNode(this);
            this.domRefs.list = _reactDom2.default.findDOMNode(this.refs.list);
            this.domRefs.headerRefresh = _reactDom2.default.findDOMNode(this.refs.header);
            this.domRefs.footerRefresh = _reactDom2.default.findDOMNode(this.refs.footer);

            //寻找document对象, 不通过window.document是因为有可能组件被渲染到其他iframe中
            //当script和dom不再同一个window对象下时, 会导致touchstart监听失败
            var node = this.domRefs.domNode.parentNode;

            while (node && node.constructor.toString().indexOf('HTMLDocument') == -1) {
                node = node.parentNode;
            }

            if (node) {
                this.domRefs.document = node;
            } else {
                this.domRefs.document = document;
            }
        }
    }, {
        key: 'render',
        value: function render() {

            var styles = getStyles(this.props, this.context);

            //头部PullRefresh图标
            var refreshLoading = _react2.default.createElement(_Refresher2.default, {
                ref: 'header',
                style: { position: 'absolute', top: 0 },
                enable: this.state.enable[_constant.SIDE.TOP],
                type: this.props.loadingStyle,
                distanceToRefresh: this.props.distanceToRefresh,
                statusLabel: this.props.refreshStatusLabel,
                color: styles.refresh.color,
                direction: _constant.DIRECTION.DOWN,
                status: this.state.status

            });

            //内容区
            var content = _react2.default.createElement(
                'div',
                {
                    ref: 'list',
                    style: styles.content
                },
                _react2.default.createElement('div', { ref: 'fixKeyboardJumpHook', style: styles.fixKeyboardJumpTop }),
                this.props.children,
                _react2.default.createElement('div', { ref: 'fixKeyboardJumpHook', style: styles.fixKeyboardJumpBottom })
            );

            //底部LoadMore图标
            var moreLoading = _react2.default.createElement(_Refresher2.default, {
                ref: 'footer',
                style: { position: 'absolute', bottom: 0 },
                enable: this.state.enable[_constant.SIDE.BOTTOM],
                type: this.props.loadingStyle,
                distanceToRefresh: this.props.distanceToRefresh,
                statusLabel: this.props.moreStatusLabel,
                color: styles.more.color,
                direction: _constant.DIRECTION.UP,
                status: this.state.status

            });

            return _react2.default.createElement(
                'div',
                { style: styles.root,
                    className: this.props.className

                    //onTouchStart={this._eventHandler.dragStart}
                    , onTouchMove: this._eventHandler.dragMove,
                    onTouchEnd: this._eventHandler.dragEnd

                },
                refreshLoading,
                content,
                moreLoading,
                _react2.default.createElement(_ScrollBar2.default, {
                    ref: 'scrollBar'
                })
            );
        }
    }]);

    return WrapperForSimulate;
}(_react2.default.Component);

WrapperForSimulate.propTypes = _props.propTypes;
WrapperForSimulate.defaultProps = _props.defaultProps;
exports.default = WrapperForSimulate;