'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _inlineStylePrefixer = require('inline-style-prefixer');

var _inlineStylePrefixer2 = _interopRequireDefault(_inlineStylePrefixer);

var _LoadingIcon = require('./LoadingIcon');

var _LoadingIcon2 = _interopRequireDefault(_LoadingIcon);

var _ArrowIcon = require('./ArrowIcon');

var _ArrowIcon2 = _interopRequireDefault(_ArrowIcon);

var _pixel = require('./pixel');

var _constant = require('./constant');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; } /**
                                                                                                                                                                                                                   * Created by TonyJiang on 16/3/30.
                                                                                                                                                                                                                   */


// import SVGNavigationArrowDownward from '../../svg-icons/navigation/arrow-downward';
// import RefreshIndicator from '../../RefreshIndicator';

function getStyles(props, state) {
    var _iconWrapper;

    var prefixer = new _inlineStylePrefixer2.default();

    var beforeRotateStyle = props.direction == _constant.DIRECTION.UP ? 'rotateZ(180deg)' : 'rotateZ(0deg)';
    var afterRotateStyle = props.direction == _constant.DIRECTION.UP ? 'rotateZ(0deg)' : 'rotateZ(180deg)';

    var styles = {
        root: Object.assign({
            display: props.enable ? 'block' : 'none',
            position: 'relative',
            left: 0,
            width: '100%',
            height: '1.2rem', //40px,
            // lineHeight: '1.2rem' , //40px
            color: props.color,
            textAlign: 'center'
        }, props.style || {}),

        iconWrapper: (_iconWrapper = {
            display: 'flex'
        }, _defineProperty(_iconWrapper, 'display', '-webkit-flex'), _defineProperty(_iconWrapper, 'justifyContent', 'center'), _defineProperty(_iconWrapper, 'WebkitJustifyContent', 'center'), _defineProperty(_iconWrapper, 'paddingTop', (0, _pixel.px2rem)(10)), _defineProperty(_iconWrapper, 'paddingBottom', (0, _pixel.px2rem)(10)), _iconWrapper),

        arrowIcon: {
            width: '0.8rem', //30px,
            height: '0.8rem', //30,
            color: props.color,
            display: state.status === _constant.STATUS.DOING ? 'none' : '',
            transformOrigin: 'center',
            transitionDuration: '400ms',
            WebkitTransitionDuration: '400ms',
            // transitionDuration : '0ms',
            // WebkitTransitionDuration : '0ms',
            transform: state.status == _constant.STATUS.TRIGGER ? afterRotateStyle : beforeRotateStyle,
            WebkitTransform: state.status == _constant.STATUS.TRIGGER ? afterRotateStyle : beforeRotateStyle
        },

        loadingIcon: {
            width: '0.8rem', //30px,
            height: '0.8rem', //30,
            color: props.color,
            display: state.status === _constant.STATUS.DOING ? '' : 'none'

        }

    };

    var prefixStyles = prefixer.prefix(styles);

    return prefixStyles;
}

var Refresher = function (_React$Component) {
    _inherits(Refresher, _React$Component);

    function Refresher() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Refresher);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Refresher.__proto__ || Object.getPrototypeOf(Refresher)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            status: _constant.STATUS.INITIAL,
            show: false
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Refresher, [{
        key: 'shouldComponentUpdate',


        //目前refresher所有操作都不通过props或者state进行控制,避免VirtualList刷新时频繁导致Refresher render
        value: function shouldComponentUpdate() {
            return false;
        }
    }, {
        key: 'componentWillMount',
        value: function componentWillMount() {

            this._initDomRefs();
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            _reactDom2.default.findDOMNode(this.refs.loadingIcon).style['-webkit-animation'] = 'chanjet_wrapper_circle 1s infinite linear';
            // this.refs.loadingIcon.style['-webkit-animation'] = 'chanjet_wrapper_circle 1s infinite linear';
        }
    }, {
        key: 'updateStatus',
        value: function updateStatus(status) {

            var beforeRotateStyle = this.props.direction == _constant.DIRECTION.UP ? 'rotateZ(180deg)' : 'rotateZ(0deg)';
            var afterRotateStyle = this.props.direction == _constant.DIRECTION.UP ? 'rotateZ(0deg)' : 'rotateZ(180deg)';
            var loadingIcon = _reactDom2.default.findDOMNode(this.refs.loadingIcon);
            var arrowIcon = _reactDom2.default.findDOMNode(this.refs.arrowIcon);

            this.state.status = status;

            switch (status) {
                case _constant.STATUS.INITIAL:

                    arrowIcon.style['transform'] = arrowIcon.style['-webkit-transform'] = beforeRotateStyle;
                    loadingIcon.style.display = 'none';
                    arrowIcon.style.display = 'block';

                    break;

                case _constant.STATUS.TRIGGER:

                    arrowIcon.style['transform'] = arrowIcon.style['-webkit-transform'] = afterRotateStyle;
                    loadingIcon.style.display = 'none';
                    arrowIcon.style.display = 'block';

                    break;

                case _constant.STATUS.DOING:

                    loadingIcon.style.display = 'block';
                    arrowIcon.style.display = 'none';

                    break;

            }

            // this.setState({status : status});
        }
    }, {
        key: '_initDomRefs',
        value: function _initDomRefs() {
            this.domRefs = {
                arrowIcon: _reactDom2.default.findDOMNode(this.refs.arrowIcon)
            };
        }
    }, {
        key: 'render',
        value: function render() {
            // console.log('refresher.render' , this.state.status);

            var styles = getStyles(this.props, this.state);

            // const icon = (
            //     <div style={styles.iconWrapper}>
            //         <RefreshIndicator
            //             ref="loadingIcon"
            //             status="loading"
            //             size={px2rem(60)}
            //             loadingColor={styles.loadingIcon.color}
            //             style={styles.loadingIcon}
            //         />
            //         <SVGNavigationArrowDownward
            //             ref="arrowIcon"
            //             color={styles.arrowIcon.color}
            //             style={styles.arrowIcon}
            //         />
            //     </div>
            //
            // );

            var animation = _react2.default.createElement(
                'style',
                null,
                '\n                @-webkit-keyframes chanjet_wrapper_circle{\n                    0%{ -webkit-transform:rotate(0deg); }\n                    100%{ -webkit-transform:rotate(360deg); }\n                }\n            '
            );

            var icon = _react2.default.createElement(
                'div',
                { style: styles.iconWrapper },
                animation,
                _react2.default.createElement(_LoadingIcon2.default, {
                    ref: 'loadingIcon',
                    loadingColor: styles.loadingIcon.color,
                    style: styles.loadingIcon
                }),
                _react2.default.createElement(_ArrowIcon2.default, {
                    ref: 'arrowIcon',
                    color: styles.arrowIcon.color,
                    style: styles.arrowIcon
                })
            );

            var label = _react2.default.createElement(
                'label',
                { ref: 'refreshLabel' },
                this.props.statusLabel[this.state.status]
            );

            var content = this.props.type == _constant.TYPE.ICON ? icon : label;

            return _react2.default.createElement(
                'div',
                { ref: 'refresh', style: styles.root },
                content
            );
        }
    }]);

    return Refresher;
}(_react2.default.Component);

Refresher.TYPE = _constant.TYPE;
Refresher.STATUS = _constant.STATUS;
Refresher.STATUS_LABEL = _constant.REFRESH_STATUS_LABEL;
Refresher.propTypes = {
    enable: _react2.default.PropTypes.bool,
    type: _react2.default.PropTypes.oneOf([_constant.TYPE.ICON, _constant.TYPE.LABEL]),
    statusLabel: _react2.default.PropTypes.object,
    distanceToRefresh: _react2.default.PropTypes.number,
    direction: _react2.default.PropTypes.oneOf([_constant.DIRECTION.DOWN, _constant.DIRECTION.UP]),
    status: _react2.default.PropTypes.oneOf([_constant.STATUS.INITIAL, _constant.STATUS.TRIGGER, _constant.STATUS.DOING, _constant.STATUS.DONE]),
    color: _react2.default.PropTypes.string,

    requestData: _react2.default.PropTypes.func,
    watcher: _react2.default.PropTypes.func

};
Refresher.defaultProps = {
    enable: true,
    type: _constant.TYPE.ICON,
    statusLabel: _constant.REFRESH_STATUS_LABEL,
    distanceToRefresh: (0, _pixel.px2px)(45 * 2, true),
    direction: _constant.DIRECTION.DOWN,
    status: _constant.STATUS.INITIAL,
    color: "black",

    requestData: function requestData() {},
    watcher: function watcher() {}
};
exports.default = Refresher;