'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * 模拟滚动条, 解决在部分安卓上DIV不显示滚动条的问题
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by TonyJiang on 16/4/3.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


function getStyles(props, state) {

    var toggleTime = state.show ? 250 : 500;

    return {
        root: {
            //spacing
            position: 'absolute',
            right: 1,
            // top:state.outerDeltaY,
            top: 0,
            bottom: 0,
            width: '0.05rem', //2px
            opacity: state.show ? 1 : 0,
            zIndex: 3,

            borderRadius: '0.05rem', //2px
            pointerEvents: 'none',
            transitionProperty: 'opacity',
            transitionDuration: toggleTime + 'ms'
        },

        content: {
            position: 'absolute',
            top: 0,
            width: '100%',
            height: state.height,
            borderRadius: 2,
            backgroundColor: 'grey',
            transitionDuration: '0ms',
            transitionTimingFunction: 'cubic-bezier(0.165, 0.84, 0.44, 1)',
            transform: 'translate3d(0px , ' + state.top + 'px , 0px)',
            //兼容 老版本 ios <8.3 , safari动画兼容性问题. 使用webkit前缀
            WebkitTransform: 'translate3d(0px , ' + state.top + 'px , 0px)'
        }
    };
}

var ScrollBar = function (_React$Component) {
    _inherits(ScrollBar, _React$Component);

    function ScrollBar() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ScrollBar);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ScrollBar.__proto__ || Object.getPrototypeOf(ScrollBar)).call.apply(_ref, [this].concat(args))), _this), _this.defaultProps = {
            show: false
        }, _this.state = {
            deltaY: 0,
            top: 0,
            height: '0%',
            show: false,
            press: false
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(ScrollBar, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            //组件被销毁时, 清除掉hide的timeout
            clearTimeout(this._hideTimer);
        }
    }, {
        key: 'show',
        value: function show() {
            this.setState({ show: true, press: true });
        }
    }, {
        key: 'hide',
        value: function hide() {
            this._hide(50);
        }
    }, {
        key: 'scrollTo',
        value: function scrollTo(scrollData) {
            this._deltaYChange(scrollData);
        }
    }, {
        key: '_deltaYChange',
        value: function _deltaYChange(newData) {
            var deltaY = newData.deltaY,
                contentHeight = newData.contentHeight,
                clientHeight = newData.clientHeight;


            var height = Math.abs(Math.max(Math.min(clientHeight / contentHeight, 1) * clientHeight, 40));

            //当前y轴百分比
            var percent = deltaY / (contentHeight - clientHeight);
            //调整当前视窗追加高度 , 随着高度增加 , y轴适当向下调整 , 直到100%时 , y轴基准位置变成窗口底部
            percent = (deltaY + percent * clientHeight) / contentHeight;

            var top = Math.abs(percent * (clientHeight - height));

            this._updateScrollBar(0, top, height);
        }
    }, {
        key: '_updateScrollBar',
        value: function _updateScrollBar(deltaY, top, height) {
            var ease = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'cubic-bezier(0.165, 0.84, 0.44, 1)';
            var duration = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;


            this.refs.content.style.height = height + 'px';
            this.refs.content.style['transition-duration'] = this.refs.content.style['-webkit-transition-duration'] = duration + 'ms';
            this.refs.content.style['transition-timing-function'] = this.refs.content.style['-webkit-transition-timing-function'] = ease;
            this.refs.content.style.transform = this.refs.content.style['-webkit-transform'] = 'translate3d(0px ,' + top + 'px , 0px)';
        }
    }, {
        key: '_hide',
        value: function _hide(duration) {
            var _this2 = this;

            // console.log('scrollbar hide in',duration , 'ms');
            clearTimeout(this._hideTimer);
            this._hideTimer = setTimeout(function () {
                // console.log('延迟隐藏, 触发');
                _this2.setState({ show: false });
            }, duration);
        }
    }, {
        key: 'render',
        value: function render() {

            var styles = getStyles(this.props, this.state);

            return _react2.default.createElement(
                'div',
                { style: styles.root },
                _react2.default.createElement('div', { ref: 'content', style: styles.content })
            );
        }
    }]);

    return ScrollBar;
}(_react2.default.Component);

ScrollBar.propTypes = {
    show: _react2.default.PropTypes.bool
};
exports.default = ScrollBar;