'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.defaultProps = exports.propTypes = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pixel = require('./pixel');

var _constant = require('./constant');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
    //是否启用顶部下拉刷新 , 默认值: true
    // enableRefresh: React.PropTypes.bool,
    //是否启动底部上拉加载 , 默认值: true
    // enableLoadMore: React.PropTypes.bool,
    //处于loading状态后延迟多长时间真正触发事件 , 默认值: 0
    loadingMinTime: _react2.default.PropTypes.number,
    //顶部和底部触发刷新时, 显示文字还是图标, 默认图标
    loadingStyle: _react2.default.PropTypes.oneOf([_constant.TYPE.ICON, _constant.TYPE.LABEL]),

    displayWidth: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),
    displayHeight: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.number, _react2.default.PropTypes.string]),

    //refresh提示的颜色 , icon 或者 文字的颜色
    refreshColor: _react2.default.PropTypes.string,
    //refresh提示的颜色 , icon 或者 文字的颜色
    moreColor: _react2.default.PropTypes.string,

    className: _react2.default.PropTypes.string,

    //弹性系数 , 默认值: 2.5
    resistance: _react2.default.PropTypes.number,
    //触发刷新的距离 , 默认值: 45
    distanceToRefresh: _react2.default.PropTypes.number,
    //是否强制使用模拟版
    useSimulate: _react2.default.PropTypes.bool,

    //触发刷新的回调函数
    refreshHandler: _react2.default.PropTypes.func,
    //触发加载更多的回调函数
    moreHandler: _react2.default.PropTypes.func,
    //触发滚动事件
    scrollHandler: _react2.default.PropTypes.func,

    //刷新状态对应的文字
    refreshStatusLabel: _react2.default.PropTypes.object,
    //加载更多状态对应的文字
    moreStatusLabel: _react2.default.PropTypes.object,

    //内容区的背景色设置
    contentBackgroundColor: _react2.default.PropTypes.string,

    //内容区后边在LoadMore和PullRefresh时能看到的背景
    totalBackgroundColor: _react2.default.PropTypes.string

}; /**
    * Created by TonyJiang on 16/5/30.
    */


var defaultProps = {
    enableRefresh: true,
    enableLoadMore: true,
    loadingMinTime: 0,
    loadingStyle: _constant.TYPE.ICON,

    displayWidth: '100%',
    displayHeight: '100%',

    refreshColor: 'black',
    moreColor: 'black',

    className: '',

    resistance: 2.5,
    distanceToRefresh: (0, _pixel.px2px)(45 * 2, true),
    useSimulate: false,

    refreshStatusLabel: {
        'init': '下拉刷新',
        'trigger': '松开刷新',
        'loading': '正在刷新...',
        'done': '完成'
    },
    moreStatusLabel: {
        'init': '上拉加载',
        'trigger': '松开加载',
        'loading': '正在加载...',
        'done': '完成'
    },

    contentBackgroundColor: '#FFFFFF',
    rootBackgroundColor: '#F5F5F5'
};

exports.propTypes = propTypes;
exports.defaultProps = defaultProps;