/**
 * Created by TonyJiang on 16/5/30.
 */
import React from 'react';

import {propTypes , defaultProps} from '../common/props';

import WrapperForNative from '../WrapperForNative';
import WrapperForSimulate from '../WrapperForSimulate';

class Scroller extends React.Component{
    
    static propTypes = propTypes;
    static defaultProps = defaultProps;
    

    state = {};

    componentWillMount(){

        if(mutants.env.os == mutants.env.constant.os.ios ){
            this.state.wrapper = WrapperForSimulate;
        }else{
            this.state.wrapper = WrapperForNative;
        }
        
    }

    //提供对外滚动方法
    scrollTo(deltaY , duration=0){
        this.refs.scroller.scrollTo(deltaY, duration);
    }



    render(){

        const {children , ...props} = this.props;

        return (
            <this.state.wrapper
                ref="scroller"
                {...props}
            >
                {children}
            </this.state.wrapper>
        )
        
        
    }
    
};

export default Scroller;