/**
 * Created by TonyJiang on 16/5/30.
 */
import React from 'react';
import {px2px} from './pixel';
import {TYPE} from './constant';


const propTypes = {
    //是否启用顶部下拉刷新 , 默认值: true
    // enableRefresh: React.PropTypes.bool,
    //是否启动底部上拉加载 , 默认值: true
    // enableLoadMore: React.PropTypes.bool,
    //处于loading状态后延迟多长时间真正触发事件 , 默认值: 0
    loadingMinTime: React.PropTypes.number,
    //顶部和底部触发刷新时, 显示文字还是图标, 默认图标
    loadingStyle: React.PropTypes.oneOf([TYPE.ICON, TYPE.LABEL]),

    displayWidth: React.PropTypes.oneOfType([React.PropTypes.number, React.PropTypes.string]),
    displayHeight: React.PropTypes.oneOfType([React.PropTypes.number, React.PropTypes.string]),

    //refresh提示的颜色 , icon 或者 文字的颜色
    refreshColor: React.PropTypes.string,
    //refresh提示的颜色 , icon 或者 文字的颜色
    moreColor: React.PropTypes.string,

    className: React.PropTypes.string,

    //弹性系数 , 默认值: 2.5
    resistance: React.PropTypes.number,
    //触发刷新的距离 , 默认值: 45
    distanceToRefresh: React.PropTypes.number,
    //是否强制使用模拟版
    useSimulate: React.PropTypes.bool,

    //触发刷新的回调函数
    refreshHandler: React.PropTypes.func,
    //触发加载更多的回调函数
    moreHandler: React.PropTypes.func,
    //触发滚动事件
    scrollHandler: React.PropTypes.func,

    //刷新状态对应的文字
    refreshStatusLabel: React.PropTypes.object,
    //加载更多状态对应的文字
    moreStatusLabel: React.PropTypes.object,

    //内容区的背景色设置
    contentBackgroundColor: React.PropTypes.string,

    //内容区后边在LoadMore和PullRefresh时能看到的背景
    totalBackgroundColor: React.PropTypes.string



};

const defaultProps = {
    enableRefresh: true,
    enableLoadMore: true,
    loadingMinTime: 0,
    loadingStyle: TYPE.ICON,

    displayWidth: '100%',
    displayHeight: '100%',

    refreshColor: 'black',
    moreColor: 'black',

    className: '',

    resistance: 2.5,
    distanceToRefresh: px2px(45 * 2, true),
    useSimulate: false,

    refreshStatusLabel: {
        'init': '下拉刷新',
        'trigger': '松开刷新',
        'loading': '正在刷新...',
        'done': '完成'
    },
    moreStatusLabel: {
        'init': '上拉加载',
        'trigger': '松开加载',
        'loading': '正在加载...',
        'done': '完成'
    },

    contentBackgroundColor: '#FFFFFF',
    rootBackgroundColor: '#F5F5F5'
};

export {propTypes , defaultProps};
